
;****************************************************************************************
;*                            LED BLITZLICHT                                            *
;*                              12.01.18                                                *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC12F683                                                  *
;* ALS OSZILLATOR WURDE INTERN RC-OSZILLATOR MIT 8,00MHZ GENOMMEN.                      *
;* (T=0.125SEC ALSO DIE TAKTZEIT)                                                      *
;* EIN BEFEHL HAT MEIST 4 TAKTE SIND 0,5SEC                                            *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;****************************************************************************************

        LIST    P=12F683       
        TITLE   "BLITZLICHT"

        ERRORLEVEL -302
        INCLUDE <P12F683.INC>

__CONFIG _INTRC_OSC_NOCLKOUT &_INTOSCIO & _IESO_OFF & _FCMEN_OFF &_WDT_OFF & _PWRTE_OFF & _BOD_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


AD_H                    EQU 0X22               ;AD WERT
AD_L                    EQU 0X23

HELP                    EQU 0X24               ;FR PAUSE ZS
HELP1                   EQU 0X25               ;FR PAUSE ZS

;FR SPORADISCHE TABELLE
ZAEHLER                 EQU 0X26
TXT                     EQU 0X27
ZAEHLER_ZU              EQU 0X28
TXT_ZU                  EQU 0X29

;FR RUNTER DIMMEN
HELL_L                  EQU 0X2A
DUNKEL_L                EQU 0X2B
HELL0_L                 EQU 0X2C
DUNKEL0_L               EQU 0X2D





;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

;STEHT NICHT IN INCULDED DATEI
GP1         EQU 1   ;MOSFET LED
GP4         EQU 4   ;SCHALTER DOPPELTE PAUSEN-ZEIT

;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE     

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              04.05.12                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK1

;OSCILLATOR AUF 8MHZ INTERN EINSTELLEN
                        MOVLW   B'01110101'
                        MOVWF   OSCCON

                        MOVLW   B'11111101'                 ;GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

                        MOVLW   B'00110100'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP DIGITAL I/O     AN3 -ANALOG/DIGITAL WANDLER MIT QUARZ-TAKT-INTERN  

;INIT TIMER 0 FUER 100MSEC 
                MOVLW   B'10000111'   ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                      ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG    ;MANCHMAL HEISST ES AUCH NUR OPTION AN STELLE VON OPTION_REG


                        BANK0                    

                        CLRF    GPIO
     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON0

                        BCF     GPIO, GP1                   ;LED AUS

;INIT TIMER 1 
                        MOVLW   B'00000000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [00]1:1 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'10001000' ;ADMF=1 RECHTSBNDIG, VDD ALS REF, CHANNEL AN2, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZEITSCHLEIFE 300MSEC   ZUM AUFLADEN VON 47NF KONDENSATOR AM SCHLEIFER VOM EINSTELLREGLER FR AD-MESSUNG
                MOVLW   D'3'
                CALL    ZS100MSEC

                CLRF    ZAEHLER
                CLRF    ZAEHLER_ZU
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
START

;AD-WANDLUNG
                BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                CALL    MUE40               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                CALL    MUE40               ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    

;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;MAX. 0X03FF ZU 0XFF MACHEN / ALSO 2MAL RECHTS SCHIEBEN
                        RRF     AD_H, F
                        RRF     AD_L, F
                        BCF     STATUS, C

                        RRF     AD_H, F
                        RRF     AD_L, F
                        BCF     STATUS, C

;AUSWERTUNG (255DEZ(0XFF) : 3TEILE = 85DEZ [0X55])
;VON 0X00 BIS 0X55(85DEZ)
;ALSO KLEINER 0X55(85DEZ) == OHNE VORBLITZ
                MOVLW   D'85'            ;IN W DEZ. 85 LADEN
                SUBWF   AD_L, W          ;AD_L - W(D'85') =>ERGEBNIS IN W / AD_L BLEIBT ERHALTEN
                BTFSS   STATUS, C        ;CARRY-ABFRAGE 
                GOTO    BLITZ            ;AD_L IST KLEINER BEI 0
                ;GOTO    GLEICH_GROESSER ;AD_L IST GLEICH + GROESSER BEI 1

;VON 0X55(85DEZ) BIS 0XAA(170DEZ)
;ALSO KLEINER 0XAA(170DEZ) == MIT ZUFLLIGEM VORBLITZ
                MOVLW   D'170'           ;IN W DEZ. 170 LADEN
                SUBWF   AD_L, W          ;AD_L - W(D'170') =>ERGEBNIS IN W / AD_L BLEIBT ERHALTEN
                BTFSS   STATUS, C        ;CARRY-ABFRAGE 
                GOTO    VORBLITZ_ZUFALL  ;AD_L IST KLEINER BEI 0
                ;GOTO    GLEICH_GROESSER ;AD_L IST GLEICH + GROESSER BEI 1

;BEI GRSSER/GLEICH DEZ170 IMMER MIT VORBLITZ
;HIER MIT VORBLITZ 2MAL
VORBLITZ                BSF     GPIO, GP1   ;BLITZ-LED EIN
                        MOVLW   D'30'
                        CALL    ZS1MSEC
                        BCF     GPIO, GP1   ;BLITZ-LED AUS

                        MOVLW   D'65'
                        CALL    ZS1MSEC

                        BSF     GPIO, GP1   ;BLITZ-LED EIN
                        MOVLW   D'30'
                        CALL    ZS1MSEC
                        BCF     GPIO, GP1   ;BLITZ-LED AUS

                        MOVLW   D'52'
                        CALL    ZS10MSEC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BLITZ                   BSF     GPIO, GP1   ;BLITZ-LED EIN
                        MOVLW   D'27' 
                        CALL    ZS10MSEC
;EINE PERIODE!!!!5SEC MIT EIN/AUS LED
;GESAMT: 0XFF = 255DEZ. DURCHLUFE * 2,5SEC = CA.0,637MSEC  !!!
;
;25MSEC : 0,637MSEC = ZYKLUS = 39
;
;255DEZ : 39 = 6,5    GENOMMEN 6DEZ MIT +/-
;

;ABSCHWELLEND START MIT :
                MOVLW   0X02
                MOVWF   DUNKEL0_L

                MOVLW   0XFF
                MOVWF   HELL0_L



RUNTER                  MOVF    HELL0_L, W
                        MOVWF   HELL_L                 

                        BSF     GPIO, GP1       ;LED EIN

WEITER1                 NOP
                        NOP
                        NOP
                        NOP
                        NOP         ;5NOPS * 0,5SEC= 2,5SEC

                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP

                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        MOVLW   D'1'        ;DURCHLAUF-ENDE ERKENNUNG
                        SUBWF   HELL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1
 
;------------------------------- 
SE1                     MOVF    DUNKEL0_L, W
                        MOVWF   DUNKEL_L                 

                        BCF     GPIO, GP1       ;LED AUS

WEITER2                 NOP
                        NOP
                        NOP
                        NOP
                        NOP         ;5NOPS * 0,5SEC= 2,5SEC
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP

                        NOP
                        NOP
                        NOP
                        NOP
                        NOP
 
                        MOVLW   D'1'            ;DURCHLAUF-ENDE ERKENNUNG
                        SUBWF   DUNKEL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2

;-------------------------------
                        MOVLW   D'6'            ;DURCHLAUF-ENDE ERKENNUNG
                        ADDWF   DUNKEL0_L, F
 
                        MOVLW   D'6'            ;DURCHLAUF-ENDE ERKENNUNG
                        SUBWF   HELL0_L, F
                        BTFSC   STATUS, C
                        GOTO    RUNTER

;TEST1
                        ;BCF     GPIO, GP1   ;BLTZ-LED AUS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;HIER KOMMT DIE PAUSE REIN ZWISCHEN DEM BLITZ NICHT LEUCHTEN
;PAUSE IMMER SPORADISCH ZUFLLIG
SPOR                CALL    TABELLE
                    MOVWF   TXT
                    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSS   STATUS, Z
                    GOTO    WEITERX
                    MOVLW   D'0'            ;TABELLENENDE ERKANNT
                    MOVWF   ZAEHLER
                    GOTO    SPOR

WEITERX             INCF    ZAEHLER, F

;PAUSE 100MSEC * TXT-WERT
                    MOVF    TXT, W
                    CALL    ZS100MSEC

                    BTFSC   GPIO, GP4       ;SCHALTER BEI LOW SPORADISCHE PAUSE PLUS NOCHMALS DIE HLFTE MEHR SO LANG
                    GOTO    START

                    RRF     TXT, W
                    ;MOVF    TXT, W
                    CALL    ZS100MSEC
                    GOTO    START

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VORBLITZ_ZUFALL     CALL    TABELLE_ZU
                    MOVWF   TXT_ZU
                    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT_ZU, W
                    BTFSS   STATUS, Z
                    GOTO    WEITERY
                    MOVLW   D'0'            ;TABELLENENDE ERKANNT
                    MOVWF   ZAEHLER_ZU
                    GOTO    VORBLITZ_ZUFALL

WEITERY             INCF    ZAEHLER_ZU, F

                    MOVLW   D'1'
                    SUBWF   TXT_ZU, W
                    BTFSS   STATUS, Z
                    GOTO    BLITZ
                    GOTO    VORBLITZ        ;BEI D'1' MIT VORBLITZ

;*****************************************************************************
;*                              CA. 40S ZEITSCHLEIFE                        *
;*****************************************************************************
MUE40       MOVLW   D'8'
            MOVWF   HELP
MU          NOP             
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP                        ;10*NOPS = 10*0,5SEC=5SEC   5SEC*8=40SEC
            DECFSZ  HELP, F
            GOTO    MU
            RETURN

;*****************************************************************************
;*                              UNTERPROGRAMM 1MSEC ZEITSCHLEIFE             *
;*****************************************************************************
ZS1MSEC                 MOVWF   HELP

ZS11                    MOVLW   D'248'
                        MOVWF   TMR0                    
                        BCF     INTCON, T0IF           
                
ZS12                    BTFSS   INTCON, T0IF           
                        GOTO    ZS12                    

                        DECFSZ  HELP, F               
                        GOTO    ZS11                    
               
                        RETURN

;ZEITBERECHNUNG FUER 1MSEC

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.125SEC=128SEC 
;1MS : 128SEC= 7,8125  GENOMMEN GANZAHLIG 8
;ALSO NACHRECHNUNG 
;128SEC*D'8'=1,024MSEC
;TMR0 ALSO D'256'-D'8'=D'248' ENTSPRICHT CA. 1MSEC
;248 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*                              UNTERPROGRAMM 10MSEC ZEITSCHLEIFE            *
;*****************************************************************************
ZS10MSEC                MOVWF   HELP

ZS31                    MOVLW   D'178'
                        MOVWF   TMR0                    
                        BCF     INTCON, T0IF           
                
ZS32                    BTFSS   INTCON, T0IF           
                        GOTO    ZS32                    

                        DECFSZ  HELP, F               
                        GOTO    ZS31
                    
                        RETURN

;ZEITBERECHNUNG FUER 10MS

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.125SEC=128SEC 
;10MS : 128SEC= 78,125  GENOMMEN GANZAHLIG 78
;ALSO NACHRECHNUNG 
;128SEC*D'78'=9,984MSEC
;TMR0 ALSO D'256'-D'78'=D'178' ENTSPRICHT CA. 10MSEC
;178 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*                              UNTERPROGRAMM 100MSEC ZEITSCHLEIFE           *
;*****************************************************************************
ZS100MSEC               MOVWF   HELP

ZS23                    MOVLW   D'10'
                        MOVWF   HELP1

ZS21                    MOVLW   D'178'
                        MOVWF   TMR0                    
                        BCF     INTCON, T0IF           
                
ZS22                    BTFSS   INTCON, T0IF           
                        GOTO    ZS22                    

                        DECFSZ  HELP1, F               
                        GOTO    ZS21                    

                        DECFSZ  HELP, F               
                        GOTO    ZS23                    
                        RETURN

;ZEITBERECHNUNG FUER 10MS*10=100MSEC

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.125SEC=128SEC 
;10MS : 128SEC= 78,125  GENOMMEN GANZAHLIG 78
;ALSO NACHRECHNUNG 
;128SEC*D'78'=9,984MSEC
;TMR0 ALSO D'256'-D'78'=D'178' ENTSPRICHT CA. 10MSEC
;178 DEZIMAL OBEN EINTRAGEN



    ORG 0X0200

;*****************************************************************************
;*                              UNTERPROGRAMM PAUSE NACH BLITZ               *
;*                       ZEILENWEISE EINZELN LADEN                           *
;*****************************************************************************
TABELLE
    MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0200 
    MOVWF   PCLATH

    MOVF    ZAEHLER, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F          ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;ES KOENNEN CA. 240 ZEILEN MIT RETLW EINGETRAGEN WERDEN /// ALSO BIS SPEICHERENDE 0X2FF /// KONTROLLIERE LIST-FILE

    RETLW D'25'     ;BEISPIEL : 25*100MSEC=2500MSEC=2,5SEC
    RETLW D'50' 
    RETLW D'70' 
    RETLW D'20' 
    RETLW D'35'      ;2 IST IST DIE KLEINSTE ZAHL WELCHE MAN EINTRAGEN KANN / ALSO 200MSEC / NULL + 1 GEHT NICHT
 
    RETLW D'15'  
    RETLW D'80'      ;255 IST DIE GRSSTE ZAHL WELCHE MAN EINTRAGEN KANN / ALSO 25,5SEC 
    RETLW D'15' 
    RETLW D'40' 
    RETLW D'30'

    RETLW D'25'  
    RETLW D'20' 
    RETLW D'30' 
    RETLW D'60' 
    RETLW D'75' 

    RETLW D'25'  
    RETLW D'90' 
    RETLW D'16' 
    RETLW D'20' 
    RETLW D'70' 

    RETLW D'40'  
    RETLW D'150' 
    RETLW D'29' 
    RETLW D'21' 
    RETLW D'50'

    RETLW D'85'  
    RETLW D'15' 
    RETLW D'29' 
    RETLW D'90' 
    RETLW D'110' 

    RETLW 0XFF      ;ENDE-ERKENNUNG


    ORG 0X0300

;*****************************************************************************
;*                              UNTERPROGRAMM ZUFALL VORBLITZ                *
;*                       ZEILENWEISE EINZELN LADEN                           *
;*****************************************************************************
TABELLE_ZU
    MOVLW   H'03'             ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
    MOVWF   PCLATH

    MOVF    ZAEHLER_ZU, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F             ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;ES KOENNEN CA. 240 ZEILEN MIT RETLW EINGETRAGEN WERDEN /// ALSO BIS SPEICHERENDE 0X3FF /// KONTROLLIERE LIST-FILE

    RETLW D'0'     ;BEI D'1' ERFOLGT VORBLITZ
    RETLW D'1' 
    RETLW D'0' 
    RETLW D'0' 
    RETLW D'1'      
 
    RETLW D'1'  
    RETLW D'1' 
    RETLW D'0' 
    RETLW D'0' 
    RETLW D'1'

    RETLW D'1'  
    RETLW D'1' 
    RETLW D'0' 
    RETLW D'0' 
    RETLW D'0' 

    RETLW D'0'  
    RETLW D'1' 
    RETLW D'1' 
    RETLW D'0' 
    RETLW D'1' 

    RETLW D'0'  
    RETLW D'0' 
    RETLW D'1' 
    RETLW D'1' 
    RETLW D'0'

    RETLW 0XFF      ;ENDE-ERKENNUNG



            END
